package org.gregoire.portknock.util;

/**
 * ID generator for transaction id's.
 *
 * @author Paul Gregoire <paul%40gregoire.org>
 * @version 0.0.1
 */
public class IDGenerator {

    private static long id = 0L;
    private static long lastId = 0L;

    /**
     * Unique to the millisecond for this JVM instance
     */
    public static long getId() {
        synchronized (IDGenerator.class) {
            id = System.currentTimeMillis();
            while (id <= lastId) {
                id++;
            }
            lastId = id;
            return id;
        }
    }

}
